kcapi_aead_encrypt
Prev | Synchronous AEAD Cipher API - One Shot | Next

## Name

kcapi_aead_encrypt — synchronously encrypt AEAD data (one shot)

## Synopsis

`ssize_t kcapi_aead_encrypt (` | struct kcapi_handle * handle,
| const uint8_t * in,
| size_t inlen,
| const uint8_t * iv,
| uint8_t * out,
| size_t outlen,
| int access`)`;

## Arguments

`handle`

  [in] cipher handle

`in`

  [in] plaintext data buffer

`inlen`

  [in] length of plaintext buffer

`iv`

  [in] IV to be used for cipher operation

`out`

  [out] data buffer holding cipher text and authentication tag

`outlen`

  [in] length of out buffer

`access`

  [in] kernel access type (KCAPI_ACCESS_HEURISTIC - use internal heuristic for fastest kernel access; KCAPI_ACCESS_VMSPLICE - use vmsplice access; KCAPI_ACCESS_SENDMSG - sendmsg access)

## Description

The AEAD cipher operation requires the furnishing of the associated authentication data. In case such data is not required, it can be set to NULL and length value must be set to zero.

It is perfectly legal to use the same buffer as the plaintext and ciphertext pointers. That would mean that after the encryption operation, the plaintext is overwritten with the ciphertext.

The memory should be aligned at the page boundary using posix_memalign(sysconf(_SC_PAGESIZE)), If it is not aligned at the page boundary, the vmsplice call may not send all data to the kernel.

The IV buffer must be exactly `kcapi_cipher_ivsize` bytes in size.

After invoking this function the caller should use `kcapi_aead_getdata_output` to obtain the resulting ciphertext and authentication tag references.

## IMPORTANT NOTE

The kernel will only process sysconf(_SC_PAGESIZE) * ALG_MAX_PAGES at one time. Longer input data cannot be handled by the kernel.

`return` number of bytes encrypted upon success; a negative errno-style error code if an error occurred

Prev | Up | Next
Synchronous AEAD Cipher API - One Shot | Home | kcapi_aead_decrypt